
  void User_Maint ( void );

  BOOL User_Init ( void );
    /*
     * The current user online is initialized.  His stats are read in from
     * the .PC file.  If not found, a new clan is created.
     *
     * Returns FALSE if user is new and didn't want to join the game.
     */

  void User_FirstTimeToday ( void );
    /*
     * Run whenever user plays first time that day.
     *
     */

  void User_Close ( void );
    /*
     * Must be called to close down the user data.  User data is written to
     * file if UpdateUser set (so that deleted users are not written to file
     * if they chose to delete themselves).
     */

  int NumMembers ( struct clan *Clan, BOOL OnlyOnesHere );
    /*
     * Returns the number of members in the clan.
     *
     * PRE: OnlyOnesHere is TRUE if only the alive members are to be checked.
     */

  void ClanStats ( struct clan *Clan, BOOL AllowModify);
    /*
     * Shows stats for given Clan with option to modify values.
     */

  BOOL GetClanID ( int ID[2], BOOL OnlyLiving, BOOL IncludeSelf,
                   int WhichAlliance, BOOL InAllianceOnly );

  void ShowPlayerStats ( struct pc *PC, BOOL AllowModify );
  char GetStat ( struct pc *PC, char Stat );

  void ListItems ( struct clan *Clan );

  BOOL GetClanNameID( char *szName, int ID[2] );

  BOOL GetClan ( int ClanID[2], struct clan *TmpClan );

  BOOL ClanExists ( int ClanID[2] );

  void PC_Create( struct pc *PC, BOOL ClanLeader );

  void Clan_Update ( struct clan *Clan );

  void ShowVillageStats ( void );

  void User_List ( void );

  void AddToDisband(void);

  void DeleteClan ( int ClanID[2], char *szClanName, BOOL Eliminate );

  void User_Destroy ( void );

  BOOL Disbanded(void);
