/*

The Clans BBS Door Game
Copyright (C) 1997-2002 Allen Ussher

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*
 * Video ADT -- x86 Architecture-specific
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>

#include "defines.h"
#include "door.h"

#define COLOR	0xB800
#define MONO	0xB000

#define CURS_NORMAL 	0
#define CURS_FAT		1
#define PADDING			''
#define SPECIAL_CODE	'%'

char o_fg4 = 7, o_bg4 = 0;

// ------------------------------------------------------------------------- //

  struct {
    long VideoType;
    long y_lookup[25];
    char far *VideoMem;
  } Video;

// ------------------------------------------------------------------------- //
  long Video_VideoType ( void )
  {
    return Video.VideoType;
  }

// ------------------------------------------------------------------------- //

  char far *vid_address ( void )
  {
    int tmp1, tmp2;

    asm {
      mov bx,0040h
      mov es,bx
      mov dx,es:63h
      add dx,6
      mov tmp1, dx           // move this into status port
    };
    Video.VideoType = COLOR;

    asm {
      mov bx,es:10h
      and bx,30h
      cmp bx,30h
      jne FC1
    };
    Video.VideoType = MONO;

    FC1:

    if (Video.VideoType == MONO)
      return ( ( void far * ) 0xB0000000L) ;
    else
      return ( ( void far * ) 0xB8000000L) ;

  }

  void ScrollUp ( void )
  {
    asm {
      mov al,1    // number of lines
      mov ch,0    // starting row
      mov cl,0    // starting column
      mov dh, 24  // ending row
      mov dl, 79  // ending column
      mov bh, 7   // color
      mov ah, 6
      int 10h     // do the scroll
    }
  }



// ------------------------------------------------------------------------- //

  void zputs (char *string)
  {
	char number[3];
	int cur_char, attr;
	char foreground, background, cur_attr;
	int i, j,  x,y;
	struct text_info TextInfo;
	static char o_fg = 7, o_bg = 0;

	gettextinfo(&TextInfo);
	x = TextInfo.curx-1;
	y = TextInfo.cury-1;

	cur_attr = o_fg | o_bg;
    cur_char = 0;

    for (;;)
    {
      if (y == 25)
      {
        /* scroll line up */
        ScrollUp();
        y = 24;
      }
      if (string[cur_char] == 0)
        break;
      if (string[cur_char] == '\b')
      {
        x--;
        cur_char++;
        continue;
      }
      if (string[cur_char] == '\r')
      {
        x = 0;
        cur_char++;
        continue;
      }
      if (x == 80)
      {
        x = 0;
        y++;

        if (y == 25)
        {
          /* scroll line up */
          ScrollUp();
          y = 24;
        }
        break;
      }
      if (string[cur_char]=='|')
      {
        if ( isdigit(string[cur_char+1]) && isdigit(string[cur_char+2]) )
        {
          number[0]=string[cur_char+1];
          number[1]=string[cur_char+2];
          number[2]=0;

          attr=atoi(number);
          if (attr>15)
          {
            background=attr-16;
            o_bg = background << 4;
            attr = o_bg | o_fg;
            cur_attr = attr;
          }
          else
          {
            foreground=attr;
            o_fg=foreground;
            attr = o_fg | o_bg;
            cur_attr = attr;
          }
          cur_char += 3;
        }
        else
        {
          Video.VideoMem[(long) (Video.y_lookup[(long) y]+ (long) (x<<1)) ] = string[cur_char];
          Video.VideoMem[(long) (Video.y_lookup[(long) y]+ (long) (x<<1) + 1L)] = cur_attr;

          cur_char++;
        }
      }
      else if (string[cur_char] == '\n')  {
        y++;
        if (y == 25)
        {
          /* scroll line up */
          ScrollUp();
          y = 24;
        }
        cur_char++;
        x = 0;
      }
      else if (string[cur_char] == 9)
      {
        /* tab */
        cur_char++;
        for (i=0;i<8;i++)
        {
          j = i + x;
          if (j > 80) break;
          Video.VideoMem[ Video.y_lookup[y]+(j<<1) ] = ' ';
          Video.VideoMem[ Video.y_lookup[y]+(j<<1) + 1] = cur_attr;
        }
        x += 8;
      }
      else
      {
        Video.VideoMem[ Video.y_lookup[y]+(x<<1) ] = string[cur_char];
        Video.VideoMem[ Video.y_lookup[y]+(x<<1) + 1] = cur_attr;

        cur_char++;
        x++;
      }
    }
    gotoxy(x+1,y+1);
  }

  void SetCurs ( int CursType )
  {
    if (CursType == CURS_NORMAL)
    {
      asm mov ah,01h
      asm mov ch,11
      asm mov cl,12
      asm int 10h
    }
    else if (CursType == CURS_FAT)
    {
      asm mov ah,01h
      asm mov ch,8
      asm mov cl,13
      asm int 10h
    }
  }

  void qputs (char *string, int x, int y)
  {
    char number[3];
    int cur_char, attr;
    char foreground, background, cur_attr;
    static o_fg = 7, o_bg = 0;
    int i, j;

    cur_attr = o_fg | o_bg;
    cur_char=0;

    while (1) {
      if (string[cur_char] == 0)
        break;
      if (x == 80)
        break;
      if (string[cur_char]=='|')    {
        if ( isdigit(string[cur_char+1]) )  {
          number[0]=string[cur_char+1];
          number[1]=string[cur_char+2];
          number[2]=0;

          attr=atoi(number);
          if (attr>15)  {
            background=attr-16;
            o_bg = background << 4;
            attr = o_bg | o_fg;
            cur_attr = attr;
          }
          else  {
            foreground=attr;
            o_fg=foreground;
            attr = o_fg | o_bg;
            cur_attr = attr;
          }
          cur_char += 3;
        }
        else  {
          Video.VideoMem[(long) (Video.y_lookup[(long) y]+ (long) (x<<1)) ] = string[cur_char];
          Video.VideoMem[(long) (Video.y_lookup[(long) y]+ (long) (x<<1) + 1L)] = cur_attr;

          cur_char++;
          x++;
        }
      }
      else if (string[cur_char] == '\n')  {
        y++;
        cur_char++;
        x = 0;
      }
      else if (string[cur_char] == 9)  {  // tab
        cur_char++;
        for (i=0;i<8;i++) {
          j = i+x;
          if (j > 80) break;
          Video.VideoMem[ Video.y_lookup[y]+(j<<1) ] = ' ';
          Video.VideoMem[ Video.y_lookup[y]+(j<<1) + 1] = cur_attr;
        }
        x += 8;
      }
      else  {
        Video.VideoMem[ Video.y_lookup[y]+(x<<1) ] = string[cur_char];
        Video.VideoMem[ Video.y_lookup[y]+(x<<1) + 1] = cur_attr;

        cur_char++;
        x++;
      }
    }

  }


  void sdisplay( char *string, int x, int y, char color, int length, int input_length )
  {
    int i, offset;
    char *pString;

    pString = string;

    offset = y*160 + x*2;

    while (*pString)
    {
      Video.VideoMem[ offset ] = *pString;
      Video.VideoMem[ offset+1 ] = color;
      offset+=2;
      pString++;
    }
    for (i=length;i<input_length;i++)
    {
      Video.VideoMem[ offset ] = PADDING;
      Video.VideoMem[ offset+1 ] = 8;
      offset+=2;
    }
  }


  int LongInput( char *string, int x, int y, int input_length, char attr,
    int low_char, int high_char)
  {
    int length = strlen(string);  // length of string
    int i,
		insert = FALSE,
		key,		// key inputted
		cur_letter = length; // letter we're editing right now
    char tmp_str[255];
    char first_time = TRUE; // flags if this is the first time to input
                // if TRUE, it will clear the line and input
    char old_fg4, old_bg4;

    // initialize the string here

    SetCurs(insert);
    textattr( attr );

    o_fg4 = attr&0x00FF;
    o_bg4 = attr&0xFF00;
    qputs(string, x, y);
    gotoxy(x+length+1, y+1);

    old_fg4 = o_fg4;
    o_fg4 = 8;

    for (i = length; i < input_length; i++)
      putch(PADDING);

    o_fg4 = old_fg4;

    // now edit it

    for (;;)
    {
      sdisplay( string, x, y, attr, length, input_length);

      gotoxy(x+ 1 + cur_letter, y+1);

      key = getch();

      switch( key )
      {
        case 0 :
          switch( getch() )
          {
            case 80 : // down
            case 72 : // up
              break;
            case 79 : // end
              cur_letter = length;
              break;
            case 77 :   // right
              if (cur_letter < length)
                cur_letter++;
              break;
            case 75 :   // left
              if (cur_letter)
							cur_letter--;
              break;
            case 71 : // home
              cur_letter = 0;
              break;
            case 82 : // insert
              insert = !insert;
              SetCurs(insert);
              // change cursor here
              break;
            case 83 :   // delete
              if (length && cur_letter < length)
              {
                i = cur_letter;
                while (i<length)  {
                  string[i] = string[i+1];
                  i++;
                }
                string[length] = 0;

                length--;
              }
              break;
          }
          break;

        case '\t' :
        case '\r' :     // enter
          return 1;
        case 25 : // ctrl-Y
          string[0] = 0;
          length = 0;
          cur_letter = 0;
          break;
        case '\b' : // backspace
          if (cur_letter > 0)   {
            i = cur_letter-1;

            while (i<length)
            {
              string[i] = string[i+1];
              i++;
            }
            string[length] = 0;

            length--;
            cur_letter--;
          }
          break;
        case 0x1B : // esc
          break;
        default :
          if (first_time)
          { // clear line!
            string[0] = 0;
            length = 0;
            cur_letter = 0;
          }
          if ((char)key < low_char || (char)key > high_char)  break;
          if (insert && length < input_length)  {

            strcpy(tmp_str, &string[cur_letter]);
            strcpy(&string[cur_letter+1], tmp_str);

            string[cur_letter] = key;

            length++;

            if (cur_letter<input_length)
            cur_letter++;
          }
          else if (!insert && cur_letter<input_length) {

            string[ cur_letter ] = key;

            if (cur_letter < length)
              cur_letter++;
            else if (cur_letter == length)  {
              string[cur_letter+1]=0;
              cur_letter++;
              length++;
            }
          }
        break;
      } // end of while loop
      first_time = FALSE;

    }

  }

  void Input( char *string, int length )
  {
    int cur_x, cur_y;

    cur_x = wherex()-1;
    cur_y = wherey()-1;

    LongInput( string, cur_x, cur_y, length, 15, 2, 255);
    zputs("\n");

    SetCurs(CURS_NORMAL);
  }


  void ClearArea ( char x1, char y1,  char x2, char y2, char attr)
  {
    asm {
      push ax
      push bx
      push cx
      push dx

      mov al, 0
      mov ch, y1
      mov cl, x1
      mov dh, y2
      mov dl, x2
      mov bh, attr
      mov ah, 7
      int 10h

      pop dx
      pop cx
      pop bx
      pop ax
    }
  }

  void xputs (char *string, int x, int y)
  {
    char far *VidPtr;

    VidPtr = Video.VideoMem + Video.y_lookup[y] + (x<<1);

    while (x < 80 && *string)
    {
      *VidPtr = *string;

      VidPtr += 2;
      x++;
      string++;
    }
  }

  void DisplayStr ( char *szString )
  {
    if (Door_Initialized())
      rputs(szString);
    else
      zputs(szString);
  }

// ------------------------------------------------------------------------- //

  void Video_Init ( void )
  {
    int iTemp;

    Video.VideoMem = vid_address();
    for (iTemp = 0; iTemp < 25;  iTemp++)
      Video.y_lookup[ iTemp ] = iTemp * 160;
  }

